#include <QRegularExpression>
#include "widgetdevice.h"
#include "ui_widgetdevice.h"
#include "a708_library.h"

WidgetDevice::WidgetDevice(QWidget *parent) :
    QFrame(parent), IWidgetDevice(),
    ui(new Ui::WidgetDevice)
{
    ui->setupUi(this);
    setBackClr(mCurBackClr);
    connect(ui->pushButtonShowDev, &QPushButton::clicked, this, [this](void)->void {
        emit pressedKeyBlinked(mKey);
    });
}

WidgetDevice::~WidgetDevice()
{
    delete ui;
}

void WidgetDevice::setVisibleView()
{
    ui->labelT5->setVisible(true);
    ui->labelT5Msg->setVisible(true);
    ui->labelT5Err->setVisible(true);
    ui->labelT6->setVisible(true);
    ui->labelT6Msg->setVisible(true);
    ui->labelT6Err->setVisible(true);
    ui->labelT7->setVisible(true);
    ui->labelT7Msg->setVisible(true);
    ui->labelT7Err->setVisible(true);
    ui->labelT8->setVisible(true);
    ui->labelT8Msg->setVisible(true);
    ui->labelT8Err->setVisible(true);
    ui->labelR5->setVisible(true);
    ui->labelR5Msg->setVisible(true);
    ui->labelR5Err->setVisible(true);
    ui->labelR6->setVisible(true);
    ui->labelR6Msg->setVisible(true);
    ui->labelR6Err->setVisible(true);
    ui->labelR7->setVisible(true);
    ui->labelR7Msg->setVisible(true);
    ui->labelR7Err->setVisible(true);
    ui->labelR8->setVisible(true);
    ui->labelR8Msg->setVisible(true);
    ui->labelR8Err->setVisible(true);
}

void WidgetDevice::setDisableViewDEVICE_REV_ID_A708_M_UD2()
{
    ui->labelT3->setVisible(false);
    ui->labelT3Msg->setVisible(false);
    ui->labelT3Err->setVisible(false);
    ui->labelT4->setVisible(false);
    ui->labelT4Msg->setVisible(false);
    ui->labelT4Err->setVisible(false);
    ui->labelT5->setVisible(false);
    ui->labelT5Msg->setVisible(false);
    ui->labelT5Err->setVisible(false);
    ui->labelT6->setVisible(false);
    ui->labelT6Msg->setVisible(false);
    ui->labelT6Err->setVisible(false);
    ui->labelT7->setVisible(false);
    ui->labelT7Msg->setVisible(false);
    ui->labelT7Err->setVisible(false);
    ui->labelT8->setVisible(false);
    ui->labelT8Msg->setVisible(false);
    ui->labelT8Err->setVisible(false);
    ui->labelR5->setVisible(false);
    ui->labelR5Msg->setVisible(false);
    ui->labelR5Err->setVisible(false);
    ui->labelR6->setVisible(false);
    ui->labelR6Msg->setVisible(false);
    ui->labelR6Err->setVisible(false);
    ui->labelR7->setVisible(false);
    ui->labelR7Msg->setVisible(false);
    ui->labelR7Err->setVisible(false);
    ui->labelR8->setVisible(false);
    ui->labelR8Msg->setVisible(false);
    ui->labelR8Err->setVisible(false);

    ui->labelRKOUT2Cnt->setVisible(false);
    ui->labelRKOUT3Cnt->setVisible(false);
    ui->labelRKOUT4Cnt->setVisible(false);
    ui->labelRKIN2Cnt->setVisible(false);
    ui->labelRKIN3Cnt->setVisible(false);
    ui->labelRKIN4Cnt->setVisible(false);
}

void WidgetDevice::setDisableViewDEVICE_REV_ID_A708_UD2()
{
    ui->labelT3->setVisible(false);
    ui->labelT3Msg->setVisible(false);
    ui->labelT3Err->setVisible(false);
    ui->labelT4->setVisible(false);
    ui->labelT4Msg->setVisible(false);
    ui->labelT4Err->setVisible(false);
    ui->labelT5->setVisible(false);
    ui->labelT5Msg->setVisible(false);
    ui->labelT5Err->setVisible(false);
    ui->labelT6->setVisible(false);
    ui->labelT6Msg->setVisible(false);
    ui->labelT6Err->setVisible(false);
    ui->labelT7->setVisible(false);
    ui->labelT7Msg->setVisible(false);
    ui->labelT7Err->setVisible(false);
    ui->labelT8->setVisible(false);
    ui->labelT8Msg->setVisible(false);
    ui->labelT8Err->setVisible(false);
    ui->labelR5->setVisible(false);
    ui->labelR5Msg->setVisible(false);
    ui->labelR5Err->setVisible(false);
    ui->labelR6->setVisible(false);
    ui->labelR6Msg->setVisible(false);
    ui->labelR6Err->setVisible(false);
    ui->labelR7->setVisible(false);
    ui->labelR7Msg->setVisible(false);
    ui->labelR7Err->setVisible(false);
    ui->labelR8->setVisible(false);
    ui->labelR8Msg->setVisible(false);
    ui->labelR8Err->setVisible(false);

    ui->labelRKOUT1Cnt->setVisible(false);
    ui->labelRKOUT2Cnt->setVisible(false);
    ui->labelRKOUT3Cnt->setVisible(false);
    ui->labelRKOUT4Cnt->setVisible(false);
    ui->labelRKIN1Cnt->setVisible(false);
    ui->labelRKIN2Cnt->setVisible(false);
    ui->labelRKIN3Cnt->setVisible(false);
    ui->labelRKIN4Cnt->setVisible(false);
}

void WidgetDevice::setStatistics(const DeviceStatistics &devStat, const DeviceStatisticsParametres& devStatParam)
{
    // проверка длины наработанной статистики платы
    if (devStat.mTMsg.count() != devStatParam.mCountT) {
        qDebug("%s", "bad mTMsg");
        return;
    }
    if (devStat.mTErr.count() != devStatParam.mCountT) {
        qDebug("%s", "bad mTErr");
        return;
    }
    if (devStat.mRMsg.count() != devStatParam.mCountR) {
        qDebug("%s", "bad mRMsg");
        return;
    }
    if (devStat.mRErr.count() != devStatParam.mCountR) {
        qDebug("%s", "bad mRErr");
        return;
    }
    if (devStat.mRkIn.count() != devStatParam.mCountRkIn) {
        qDebug("%s", "bad mRkIn");
        return;
    }
    if (devStat.mRkOut.count() != devStatParam.mCountRkOut) {
        qDebug("%s", "bad mRkOut");
        return;
    }
    mCurrentStatictics = devStat;
    updateStatistics(devStat);
}

void WidgetDevice::updateStatistics(const DeviceStatistics &devStat)
{
    // отобразить статистику передатчиков
    auto listT = this->findChildren<QLabel*>(QRegularExpression("labelT(\\d+)"));
    auto listTMsg = this->findChildren<QLabel*>(QRegularExpression("labelT(\\d+)Msg"));
    auto listTErr = this->findChildren<QLabel*>(QRegularExpression("labelT(\\d+)Err"));
    for (int index=0; index < devStat.mTMsg.count(); index++) {
        listTMsg[index]->setText(QString::number(devStat.mTMsg[index]));
        listTMsg[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
        if ((devStat.mTMsg[index] > 0) && (devStat.mTErr[index] == 0))
            listTMsg[index]->setStyleSheet(QString("background-color: #90EE90"));
        listTErr[index]->setText(QString::number(devStat.mTErr[index]));
        listTErr[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
        if (devStat.mTErr[index] > 0)
            listTErr[index]->setStyleSheet(QString("background-color: #CD5C5C"));
        listT[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
    }
    // отобразить статистику приёмников
    auto listR = this->findChildren<QLabel*>(QRegularExpression("labelR(\\d+)"));
    auto listRMsg = this->findChildren<QLabel*>(QRegularExpression("labelR(\\d+)Msg"));
    auto listRErr = this->findChildren<QLabel*>(QRegularExpression("labelR(\\d+)Err"));
    for (int index=0; index < devStat.mRMsg.count(); index++) {
        listRMsg[index]->setText(QString::number(devStat.mRMsg[index]));
        listRMsg[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
        if ((devStat.mRMsg[index] > 0) && (devStat.mRErr[index] == 0))
            listRMsg[index]->setStyleSheet(QString("background-color: #90EE90"));
        listRErr[index]->setText(QString::number(devStat.mRErr[index]));
        listRErr[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
        if (devStat.mRErr[index] > 0)
            listRErr[index]->setStyleSheet(QString("background-color: #CD5C5C"));
        listR[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
    }
    // отобразить статистику рк
    auto listRkIn = this->findChildren<QLabel*>(QRegularExpression("labelRKIN(\\d+)Cnt"));
    auto listRkInlb = this->findChildren<QLabel*>(QRegularExpression("labelRKIN(\\d+)"));
    for (int index=0; index < devStat.mRkIn.count(); index++) {
        listRkIn[index]->setText(QString::number(devStat.mRkIn[index]));
        listRkIn[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
        listRkInlb[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
    }
    auto listRkOut = this->findChildren<QLabel*>(QRegularExpression("labelRKOUT(\\d+)Cnt"));
    auto listRkOutlb = this->findChildren<QLabel*>(QRegularExpression("labelRKOUT(\\d+)"));
    for (int index=0; index < devStat.mRkOut.count(); index++) {
        listRkOut[index]->setText(QString::number(devStat.mRkOut[index]));
        listRkOut[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
        listRkOutlb[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
    }
    // отобразить статистику A708
    auto listA708TMsg = this->findChildren<QLabel*>(QRegularExpression("labelA708T(\\d+)Msg"));
    auto listA708RMsg = this->findChildren<QLabel*>(QRegularExpression("labelA708R(\\d+)Msg"));
    auto listA708Err = this->findChildren<QLabel*>(QRegularExpression("labelA708(\\d+)Err"));
    for (int index=0; index < devStat.mA708T.count(); index++) {
        listA708TMsg[index]->setText(QString::number(devStat.mA708T[index]));
        listA708TMsg[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
        if ( ((devStat.mA708T[index] > 0) || (devStat.mA708R[index] > 0)) && (devStat.mA708Err[index] == 0))
            listA708TMsg[index]->setStyleSheet(QString("background-color: #90EE90"));
        listA708RMsg[index]->setText(QString::number(devStat.mA708R[index]));
        listA708RMsg[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
        if ( ((devStat.mA708T[index] > 0) || (devStat.mA708R[index] > 0)) && (devStat.mA708Err[index] == 0))
            listA708RMsg[index]->setStyleSheet(QString("background-color: #90EE90"));
        listA708Err[index]->setText(QString::number(devStat.mA708Err[index]));
        listA708Err[index]->setStyleSheet(QString("background-color: %1").arg( ((index % 2)==0) ? "white" : "#D3D3D3"));
        if (devStat.mA708Err[index] > 0)
            listA708Err[index]->setStyleSheet(QString("background-color: #CD5C5C"));
    }
}

void WidgetDevice::setBackClr(WidgetDevice::BACKCLR value)
{
    mCurBackClr = value;
    this->setStyleSheet(QString("background-color: %1").arg( (mCurBackClr == BACKCLR::dark)  ? "#A9A9A9" : "#FFFAFA"));
}

QString WidgetDevice::getHtmlText()
{
    auto transmitTable = [this](void)->QString {
        QString html;
        int cnt = mCurrentStatictics.mTMsg.count();
        html += QString("<table align=\"center\" width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" >");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("ПЕРЕДАТЧИКИ:");
        for (int i=0; i<cnt; i++) {
            html += QString("<td align=\"center\"> ПРД%1 </td>").arg(QString::number(i+1));
        }
        html += QString("</tr>");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("СООБЩЕНИЯ:");
        for (int i=0; i<cnt; i++) {
            QString color;
            color = ((i % 2)==0) ? "white" : "#D3D3D3";
            if ((mCurrentStatictics.mTMsg[i] > 0) && (mCurrentStatictics.mTErr[i] == 0))
                color = "#90EE90";
            html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                    .arg(QString::number(mCurrentStatictics.mTMsg[i]))
                    .arg(color);
        }
        html += QString("</tr>");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("ОШИБКИ:");
        for (int i=0; i<cnt; i++) {
            QString color;
            color = ((i % 2)==0) ? "white" : "#D3D3D3";
            if (mCurrentStatictics.mTErr[i] > 0)
                color = "#CD5C5C";
            html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                    .arg(QString::number(mCurrentStatictics.mTErr[i])).arg(color);
        }
        html += QString("</tr>");
        html += QString("</table>");
        return html;
    };

    auto receiveTable = [this](void)->QString {
        QString html;
        int cnt = mCurrentStatictics.mRMsg.count();
        html += QString("<table align=\"center\" width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" >");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("ПРИЁМНИКИ:");
        for (int i=0; i<cnt; i++) {
            html += QString("<td align=\"center\"> ПРМ%1 </td>").arg(QString::number(i+1));
        }
        html += QString("</tr>");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("СООБЩЕНИЯ:");
        for (int i=0; i<cnt; i++) {
            QString color;
            color = ((i % 2)==0) ? "white" : "#D3D3D3";
            if ((mCurrentStatictics.mRMsg[i] > 0) && (mCurrentStatictics.mRErr[i] == 0))
                color = "#90EE90";
            html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                    .arg(QString::number(mCurrentStatictics.mRMsg[i])).arg(color);
        }
        html += QString("</tr>");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("ОШИБКИ:");
        for (int i=0; i<cnt; i++) {
            QString color;
            color = ((i % 2)==0) ? "white" : "#D3D3D3";
            if (mCurrentStatictics.mRErr[i] > 0)
                color = "#CD5C5C";
            html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                    .arg(QString::number(mCurrentStatictics.mRErr[i])).arg(color);
        }
        html += QString("</tr>");
        html += QString("</table>");
        return html;
    };

    auto rkOutTable = [this](void)->QString {
        QString html;
        int cnt = mCurrentStatictics.mRkOut.count();
        html += QString("<table align=\"center\" width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" >");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("РАЗОВЫЕ КОМАНДЫ:");
        for (int i=0; i<cnt; i++) {
            html += QString("<td align=\"center\"> ВЫХОД%1 </td>").arg(QString::number(i+1));
        }
        html += QString("</tr>");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("КОЛИЧЕСТВО:");
        for (int i=0; i<cnt; i++) {
            QString color;
            color = ((i % 2)==0) ? "white" : "#D3D3D3";
            html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                    .arg(QString::number(mCurrentStatictics.mRkOut[i])).arg(color);
        }
        html += QString("</tr>");
        html += QString("</table>");
        return html;
    };

    auto rkInTable = [this](void)->QString {
        QString html;
        int cnt = mCurrentStatictics.mRkIn.count();
        html += QString("<table align=\"center\" width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" >");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("РАЗОВЫЕ КОМАНДЫ:");
        for (int i=0; i<cnt; i++) {
            html += QString("<td align=\"center\"> ВХОД%1 </td>").arg(QString::number(i+1));
        }
        html += QString("</tr>");
        html += QString("<tr>");
        html += QString("<td align=\"left\"> %1 </td>").arg("КОЛИЧЕСТВО:");
        for (int i=0; i<cnt; i++) {
            QString color;
            color = ((i % 2)==0) ? "white" : "#D3D3D3";
            html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                    .arg(QString::number(mCurrentStatictics.mRkIn[i])).arg(color);
        }
        html += QString("</tr>");
        html += QString("</table>");
        return html;
    };

    auto a708Table = [this](void)->QString {
        QString html;
        QString color;
        html += QString("<table align=\"center\" width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" >");
        html += QString("<tr>");
        html += QString("<td align=\"center\"> %1 </td>").arg("КАНАЛЫ");
        html += QString("<td align=\"center\"> %1 </td>").arg("ПЕРЕДАНО");
        html += QString("<td align=\"center\"> %1 </td>").arg("ПРИНЯТО");
        html += QString("<td align=\"center\"> %1 </td>").arg("ОШИБКИ");
        html += QString("</tr>");
        html += QString("<tr>");
        html += QString("<td align=\"center\"> %1 </td>").arg("А708 КАНАЛ 1");
        color = "white";
        if ( ((mCurrentStatictics.mA708T[0] > 0) || (mCurrentStatictics.mA708R[0] > 0)) && (mCurrentStatictics.mA708Err[0] == 0))
            color = "#90EE90";
        html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                .arg(QString::number(mCurrentStatictics.mA708T[0])).arg(color);
        html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                .arg(QString::number(mCurrentStatictics.mA708R[0])).arg(color);
        if (mCurrentStatictics.mA708Err[0] > 0)
            color = "#CD5C5C";
        html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                .arg(QString::number(mCurrentStatictics.mA708Err[0])).arg(color);
        html += QString("</tr>");
        html += QString("<tr>");
        html += QString("<td align=\"center\"> %1 </td>").arg("А708 КАНАЛ 2");
        color = "white";
        if ( ((mCurrentStatictics.mA708T[1] > 0) || (mCurrentStatictics.mA708R[1] > 0)) && (mCurrentStatictics.mA708Err[1] == 0))
            color = "#90EE90";
        html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                .arg(QString::number(mCurrentStatictics.mA708T[1])).arg(color);
        html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                .arg(QString::number(mCurrentStatictics.mA708R[1])).arg(color);
        if (mCurrentStatictics.mA708Err[1] > 0)
            color = "#CD5C5C";
        html += QString("<td align=\"center\" bgcolor=\"%2\"> %1 </td>")
                .arg(QString::number(mCurrentStatictics.mA708Err[1])).arg(color);
        html += QString("</tr>");
        html += QString("</table>");
        return html;
    };

    QString html;
    html += QString("<font size=\"3\" face=\"Liberation Mono\">");
    html += QString("<p>");
    html += getDeviceName();
    html += QString("</p>");
    html += QString("<table align=\"center\" width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" >");
    html += QString("<tr>");
    html += QString("<td>");
    html += transmitTable();
    html += QString("</td>");
    html += QString("<td>");
    html += receiveTable();
    html += QString("</td>");
    html += QString("</tr>");
    html += QString("</table>");
    html += QString("<table align=\"center\" width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" >");
    html += QString("<tr>");
    html += QString("<td>");
    html += rkOutTable();
    html += QString("</td>");
    html += QString("<td>");
    html += rkInTable();
    html += QString("</td>");
    html += QString("</tr>");
    html += QString("</table>");
    html += a708Table();
    html += QString("</font>");
    return html;
}

void WidgetDevice::setKey(int key)
{
    mKey = key;
}

void WidgetDevice::setDeviceName(const QString &name)
{
    ui->labelDevName->setText(QString("ДЕВАЙС: %1")
                              .arg(name)
                              );
}

void WidgetDevice::setDeviceId(int id)
{
    mCurrentRevId = id;
    setVisibleView();
    switch (mCurrentRevId) {
        case DEVICE_ID_MPCIE_A708: setDisableViewDEVICE_REV_ID_A708_M_UD2(); break;
        case DEVICE_ID_PCIE_A708: setDisableViewDEVICE_REV_ID_A708_UD2(); break;
        default:break;
    }
}

void WidgetDevice::setDeviceStatistics(const DeviceStatistics &devStat)
{
    switch (mCurrentRevId) {
        case DEVICE_ID_MPCIE_A708: setStatistics(devStat, mDeviceStatisticsParametresMap.value(DEVICE_ID_MPCIE_A708)); break;
        case DEVICE_ID_PCIE_A708: setStatistics(devStat, mDeviceStatisticsParametresMap.value(DEVICE_ID_PCIE_A708)); break;
    }
}


QString WidgetDevice::getDeviceName()
{
    return ui->labelDevName->text();
}


QStringList WidgetDevice::getStringStatistics()
{
    QStringList list;
    list.append(ui->labelDevName->text());
    QString trnmtMsg = QString("ПРД СБЩ: "), trnmtErr = QString("ПРД ОШБ: ");
    for (int index = 0; index < mCurrentStatictics.mTMsg.count(); index++) {
        trnmtMsg += QString("П%1=%2; ")
                .arg(QString::number(index+1))
                .arg(QString::number(mCurrentStatictics.mTMsg[index]));
        trnmtErr += QString("П%1=%2; ")
                .arg(QString::number(index+1))
                .arg(QString::number(mCurrentStatictics.mTErr[index]));
    }
    QString recvMsg = QString("ПРМ СБЩ: "), recvErr = QString("ПРМ ОШБ: ");
    for (int index = 0; index < mCurrentStatictics.mRMsg.count(); index++) {
        recvMsg += QString("П%1=%2; ")
                .arg(QString::number(index+1))
                .arg(QString::number(mCurrentStatictics.mRMsg[index]));
        recvErr += QString("П%1=%2; ")
                .arg(QString::number(index+1))
                .arg(QString::number(mCurrentStatictics.mRErr[index]));
    }
    QString rkOut = QString("РК ВЫХ: ");
    for (int index = 0; index < mCurrentStatictics.mRkOut.count(); index++) {
        rkOut += QString("РК%1=%2; ")
                .arg(QString::number(index+1))
                .arg(QString::number(mCurrentStatictics.mRkOut[index]));
    }
    QString rkIn = QString("РК ВХД: ");
    for (int index = 0; index < mCurrentStatictics.mRkIn.count(); index++) {
        rkIn += QString("РК%1=%2; ")
                .arg(QString::number(index+1))
                .arg(QString::number(mCurrentStatictics.mRkIn[index]));
    }
    QString A708T = QString("A708 ПРД: ");
    for (int index = 0; index < mCurrentStatictics.mA708T.count(); index++) {
        A708T += QString("A708%1=%2; ")
                .arg(QString::number(index+1))
                .arg(QString::number(mCurrentStatictics.mA708T[index]));
    }
    QString A708R = QString("A708 ПРМ: ");
    for (int index = 0; index < mCurrentStatictics.mA708R.count(); index++) {
        A708R += QString("A708%1=%2; ")
                .arg(QString::number(index+1))
                .arg(QString::number(mCurrentStatictics.mA708R[index]));
    }
    QString A708Err = QString("A708 ОШБ: ");
    for (int index = 0; index < mCurrentStatictics.mA708Err.count(); index++) {
        A708Err += QString("A708%1=%2; ")
                .arg(QString::number(index+1))
                .arg(QString::number(mCurrentStatictics.mA708Err[index]));
    }
    list.append(trnmtMsg);
    list.append(trnmtErr);
    list.append(recvMsg);
    list.append(recvErr);
    list.append(rkOut);
    list.append(rkIn);   
    list.append(A708T);
    list.append(A708R);
    list.append(A708Err);
    return list;
}
